"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const css_1 = require("@emotion/css");
const react_1 = __importStar(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const general_tab_1 = __importDefault(require("./general-tab/general-tab"));
const authentication_tab_1 = __importDefault(require("./authentication-tab/authentication-tab"));
const ssh_tunnel_tab_1 = __importDefault(require("./ssh-tunnel-tab/ssh-tunnel-tab"));
const tls_ssl_tab_1 = __importDefault(require("./tls-ssl-tab/tls-ssl-tab"));
const advanced_tab_1 = __importDefault(require("./advanced-tab/advanced-tab"));
const tabsStyles = (0, css_1.css)({
    marginTop: compass_components_1.spacing[1],
});
function AdvancedOptionsTabs({ errors, connectionStringUrl, hideError, updateConnectionFormField, connectionOptions, }) {
    const [activeTab, setActiveTab] = (0, react_1.useState)(0);
    const tabs = [
        { name: 'General', component: general_tab_1.default },
        { name: 'Authentication', component: authentication_tab_1.default },
        { name: 'TLS/SSL', component: tls_ssl_tab_1.default },
        { name: 'Proxy/SSH Tunnel', component: ssh_tunnel_tab_1.default },
        { name: 'Advanced', component: advanced_tab_1.default },
    ];
    return (react_1.default.createElement(compass_components_1.Tabs, { className: tabsStyles, setSelected: setActiveTab, selected: activeTab, "aria-label": "Advanced Options Tabs" }, tabs.map((tabObject, idx) => {
        const TabComponent = tabObject.component;
        return (react_1.default.createElement(compass_components_1.Tab, { key: idx, name: tabObject.name, "aria-label": tabObject.name },
            react_1.default.createElement(TabComponent, { errors: errors, hideError: hideError, connectionStringUrl: connectionStringUrl, updateConnectionFormField: updateConnectionFormField, connectionOptions: connectionOptions })));
    })));
}
exports.default = AdvancedOptionsTabs;
//# sourceMappingURL=advanced-options-tabs.js.map