"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const css_1 = require("@emotion/css");
const react_1 = __importStar(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const markable_form_fields_1 = require("../../../constants/markable-form-fields");
const direct_connection_input_1 = __importDefault(require("./direct-connection-input"));
const form_field_container_1 = __importDefault(require("../../form-field-container"));
const hostInputContainerStyles = (0, css_1.css)({
    display: 'flex',
    flexDirection: 'row',
    width: '100%',
    marginBottom: compass_components_1.spacing[2],
});
const hostInputStyles = (0, css_1.css)({
    flexGrow: 1,
});
const hostActionButtonStyles = (0, css_1.css)({
    marginLeft: compass_components_1.spacing[1],
    marginTop: compass_components_1.spacing[1],
});
function HostInput({ errors, connectionStringUrl, updateConnectionFormField, }) {
    const [hosts, setHosts] = (0, react_1.useState)([...connectionStringUrl.hosts]);
    const { isSRV } = connectionStringUrl;
    const showDirectConnectionInput = connectionStringUrl
        .typedSearchParams()
        .get('directConnection') === 'true' ||
        (!connectionStringUrl.isSRV && hosts.length === 1);
    (0, react_1.useEffect)(() => {
        setHosts([...connectionStringUrl.hosts]);
    }, [connectionStringUrl]);
    const onHostChange = (0, react_1.useCallback)((event, index) => {
        const newHosts = [...hosts];
        newHosts[index] = event.target.value || '';
        setHosts(newHosts);
        updateConnectionFormField({
            type: 'update-host',
            hostIndex: index,
            newHostValue: event.target.value,
        });
    }, [hosts, setHosts, updateConnectionFormField]);
    const hostsErrorIndex = errors.findIndex((error) => error.fieldName === markable_form_fields_1.MARKABLE_FORM_FIELD_NAMES.HOSTS);
    const hostsError = errors[hostsErrorIndex];
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(form_field_container_1.default, null,
            react_1.default.createElement(compass_components_1.Label, { htmlFor: "connection-host-input", id: "connection-host-input-label" }, isSRV ? 'Hostname' : 'Host'),
            hosts.map((host, index) => (react_1.default.createElement("div", { className: hostInputContainerStyles, key: `host-${index}` },
                react_1.default.createElement(compass_components_1.TextInput, { className: hostInputStyles, type: "text", id: "connection-host-input", "aria-labelledby": "connection-host-input-label", state: hostsError ? 'error' : undefined, errorMessage: hostsError &&
                        hostsError.fieldName === markable_form_fields_1.MARKABLE_FORM_FIELD_NAMES.HOSTS &&
                        index === hostsError.hostIndex
                        ? hostsError.message
                        : undefined, value: `${host}`, onChange: (e) => onHostChange(e, index) }),
                !isSRV && (react_1.default.createElement(compass_components_1.IconButton, { className: hostActionButtonStyles, "aria-label": "Add new host", onClick: () => updateConnectionFormField({
                        type: 'add-new-host',
                        hostIndexToAddAfter: index,
                    }) },
                    react_1.default.createElement(compass_components_1.Icon, { glyph: "Plus" }))),
                !isSRV && hosts.length > 1 && (react_1.default.createElement(compass_components_1.IconButton, { className: hostActionButtonStyles, "aria-label": "Remove host", onClick: () => updateConnectionFormField({
                        type: 'remove-host',
                        hostIndexToRemove: index,
                    }) },
                    react_1.default.createElement(compass_components_1.Icon, { glyph: "Minus" }))))))),
        showDirectConnectionInput && (react_1.default.createElement(form_field_container_1.default, null,
            react_1.default.createElement(direct_connection_input_1.default, { connectionStringUrl: connectionStringUrl, updateConnectionFormField: updateConnectionFormField })))));
}
exports.default = HostInput;
//# sourceMappingURL=host-input.js.map