"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const form_field_container_1 = __importDefault(require("../../form-field-container"));
function Identity({ sshTunnelOptions, onConnectionOptionChanged, errors, }) {
    var _a;
    const formFieldChanged = (key, value) => {
        onConnectionOptionChanged(key, value);
    };
    const fields = [
        {
            name: 'host',
            label: 'SSH Hostname',
            type: 'text',
            optional: false,
            placeholder: 'SSH Hostname',
            value: sshTunnelOptions === null || sshTunnelOptions === void 0 ? void 0 : sshTunnelOptions.host,
            errorMessage: errors === null || errors === void 0 ? void 0 : errors.host,
            state: (errors === null || errors === void 0 ? void 0 : errors.host) ? 'error' : 'none',
        },
        {
            name: 'port',
            label: 'SSH Tunnel Port',
            type: 'number',
            optional: false,
            placeholder: 'SSH Tunnel Port',
            value: ((_a = sshTunnelOptions === null || sshTunnelOptions === void 0 ? void 0 : sshTunnelOptions.port) !== null && _a !== void 0 ? _a : '').toString(),
            errorMessage: errors === null || errors === void 0 ? void 0 : errors.port,
            state: (errors === null || errors === void 0 ? void 0 : errors.port) ? 'error' : 'none',
        },
        {
            name: 'username',
            label: 'SSH Username',
            type: 'text',
            optional: false,
            placeholder: 'SSH Username',
            value: sshTunnelOptions === null || sshTunnelOptions === void 0 ? void 0 : sshTunnelOptions.username,
            errorMessage: errors === null || errors === void 0 ? void 0 : errors.username,
            state: (errors === null || errors === void 0 ? void 0 : errors.username) ? 'error' : 'none',
        },
        {
            name: 'identityKeyFile',
            label: 'SSH Identity File',
            type: 'file',
            errorMessage: errors === null || errors === void 0 ? void 0 : errors.identityKeyFile,
            value: (sshTunnelOptions === null || sshTunnelOptions === void 0 ? void 0 : sshTunnelOptions.identityKeyFile) && sshTunnelOptions.identityKeyFile
                ? [sshTunnelOptions.identityKeyFile]
                : undefined,
        },
        {
            name: 'identityKeyPassphrase',
            label: 'SSH Passphrase',
            type: 'password',
            optional: true,
            placeholder: 'SSH Passphrase',
            value: sshTunnelOptions === null || sshTunnelOptions === void 0 ? void 0 : sshTunnelOptions.identityKeyPassphrase,
            errorMessage: errors === null || errors === void 0 ? void 0 : errors.identityKeyPassphrase,
            state: (errors === null || errors === void 0 ? void 0 : errors.identityKeyPassphrase) ? 'error' : 'none',
        },
    ];
    return (react_1.default.createElement(react_1.default.Fragment, null, fields.map(({ name, label, type, optional, placeholder, value, errorMessage, state, }) => {
        if (type === 'file') {
            return (react_1.default.createElement(form_field_container_1.default, { key: name },
                react_1.default.createElement(compass_components_1.FileInput, { id: name, dataTestId: name, onChange: (files) => {
                        formFieldChanged(name, files[0]);
                    }, label: label, error: Boolean(errorMessage), errorMessage: errorMessage, values: value, description: 'Learn More', link: 'https://mongodb.com' })));
        }
        return (react_1.default.createElement(form_field_container_1.default, { key: name },
            react_1.default.createElement(compass_components_1.TextInput, { onChange: ({ target: { value }, }) => {
                    formFieldChanged(name, name === 'port' ? Number(value) : value);
                }, name: name, "data-testid": name, label: label, type: type, optional: optional, placeholder: placeholder, value: value, errorMessage: errorMessage, state: state })));
    })));
}
exports.default = Identity;
//# sourceMappingURL=ssh-tunnel-identity.js.map