import React from 'react';
import { SSHConnectionOptions } from '../../../utils/connection-options-handler';
declare type PasswordFormKeys = keyof Omit<SSHConnectionOptions, 'identityKeyFile' | 'identityKeyPassphrase'>;
declare type PasswordFormErrors = {
    [key in PasswordFormKeys]?: string;
};
declare function Password({ sshTunnelOptions, onConnectionOptionChanged, errors, }: {
    sshTunnelOptions?: SSHConnectionOptions;
    onConnectionOptionChanged: (key: PasswordFormKeys, value: string | number) => void;
    errors?: PasswordFormErrors;
}): React.ReactElement;
export default Password;
