import React from 'react';
import { SSHConnectionOptions } from '../../../utils/connection-options-handler';
declare type SocksFormKeys = keyof Omit<SSHConnectionOptions, 'identityKeyFile' | 'identityKeyPassphrase'>;
declare type SocksFormErrors = {
    [key in SocksFormKeys]?: string;
};
declare function Socks({ sshTunnelOptions, onConnectionOptionChanged, errors, }: {
    sshTunnelOptions?: SSHConnectionOptions;
    onConnectionOptionChanged: (key: SocksFormKeys, value: string | number) => void;
    errors?: SocksFormErrors;
}): React.ReactElement;
export default Socks;
