"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const default_connection_1 = require("../../../constants/default-connection");
const form_field_container_1 = __importDefault(require("../../form-field-container"));
function Socks({ sshTunnelOptions, onConnectionOptionChanged, errors, }) {
    var _a;
    const formFieldChanged = (key, value) => {
        onConnectionOptionChanged(key, value);
    };
    const fields = [
        {
            name: 'host',
            label: 'Proxy Hostname',
            type: 'text',
            optional: false,
            placeholder: 'Proxy Hostname',
            value: sshTunnelOptions === null || sshTunnelOptions === void 0 ? void 0 : sshTunnelOptions.host,
            errorMessage: errors === null || errors === void 0 ? void 0 : errors.host,
            state: (errors === null || errors === void 0 ? void 0 : errors.host) ? 'error' : 'none',
        },
        {
            name: 'port',
            label: 'Proxy Tunnel Port',
            type: 'number',
            optional: false,
            placeholder: 'Proxy Tunnel Port',
            value: ((_a = sshTunnelOptions === null || sshTunnelOptions === void 0 ? void 0 : sshTunnelOptions.port) !== null && _a !== void 0 ? _a : default_connection_1.defaultSocksPort).toString(),
            errorMessage: errors === null || errors === void 0 ? void 0 : errors.port,
            state: (errors === null || errors === void 0 ? void 0 : errors.port) ? 'error' : 'none',
        },
        {
            name: 'username',
            label: 'Proxy Username',
            type: 'text',
            optional: false,
            placeholder: 'Proxy Username',
            value: sshTunnelOptions === null || sshTunnelOptions === void 0 ? void 0 : sshTunnelOptions.username,
            errorMessage: errors === null || errors === void 0 ? void 0 : errors.username,
            state: (errors === null || errors === void 0 ? void 0 : errors.username) ? 'error' : 'none',
        },
        {
            name: 'password',
            label: 'Proxy Password',
            type: 'password',
            optional: true,
            placeholder: 'Proxy Password',
            value: sshTunnelOptions === null || sshTunnelOptions === void 0 ? void 0 : sshTunnelOptions.password,
            errorMessage: errors === null || errors === void 0 ? void 0 : errors.password,
            state: (errors === null || errors === void 0 ? void 0 : errors.password) ? 'error' : 'none',
        },
    ];
    return (react_1.default.createElement(react_1.default.Fragment, null, fields.map(({ name, label, type, optional, placeholder, value, errorMessage, state, }) => (react_1.default.createElement(form_field_container_1.default, { key: name },
        react_1.default.createElement(compass_components_1.TextInput, { onChange: ({ target: { value }, }) => {
                formFieldChanged(name, name === 'port' ? Number(value) : value);
            }, name: name, "data-testid": name, label: label, type: type, optional: optional, placeholder: placeholder, value: value, errorMessage: errorMessage, state: state }))))));
}
exports.default = Socks;
//# sourceMappingURL=ssh-tunnel-socks.js.map