"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const css_1 = require("@emotion/css");
const compass_components_1 = require("@mongodb-js/compass-components");
const markable_form_fields_1 = require("../../../constants/markable-form-fields");
const ssh_tunnel_identity_1 = __importDefault(require("./ssh-tunnel-identity"));
const ssh_tunnel_password_1 = __importDefault(require("./ssh-tunnel-password"));
const options = [
    {
        title: 'None',
        id: 'none',
        type: 'none',
        component: function None() {
            return react_1.default.createElement(react_1.default.Fragment, null);
        },
    },
    {
        title: 'Use Password',
        id: 'password',
        type: 'password',
        component: ssh_tunnel_password_1.default,
    },
    {
        title: 'Use Identity File',
        id: 'identity',
        type: 'identity',
        component: ssh_tunnel_identity_1.default,
    },
];
const containerStyles = (0, css_1.css)({
    marginTop: compass_components_1.spacing[3],
});
const contentStyles = (0, css_1.css)({
    marginTop: compass_components_1.spacing[3],
    width: '50%',
});
function SSHTunnel({ connectionOptions, updateConnectionFormField, errors, }) {
    const [selectedOption, setSelectedOption] = (0, react_1.useState)(options[0]);
    const optionSelected = (0, react_1.useCallback)((event) => {
        event.preventDefault();
        const item = options.find(({ id }) => id === event.target.value);
        if (item) {
            setSelectedOption(item);
        }
    }, []);
    const onConnectionOptionChanged = (0, react_1.useCallback)((key, value) => {
        return updateConnectionFormField({
            type: 'update-connection-options',
            currentTab: selectedOption.type,
            key,
            value,
        });
    }, [updateConnectionFormField, selectedOption]);
    const sshTunnelErrors = errors.find(({ fieldName }) => fieldName === markable_form_fields_1.MARKABLE_FORM_FIELD_NAMES.IS_SSH);
    const SSLOptionContent = selectedOption.component;
    return (react_1.default.createElement("div", { className: containerStyles },
        react_1.default.createElement(compass_components_1.Label, { htmlFor: "ssh-options-radio-box-group" }, "SSH Tunnel/Proxy Method"),
        react_1.default.createElement(compass_components_1.RadioBoxGroup, { onChange: optionSelected, className: "radio-box-group-style" }, options.map(({ title, id, type }) => {
            return (react_1.default.createElement(compass_components_1.RadioBox, { "data-testid": `${type}-tab-button`, checked: selectedOption.id === id, value: id, key: id }, title));
        })),
        connectionOptions && (react_1.default.createElement("div", { className: contentStyles, "data-testid": `${selectedOption.type}-tab-content` },
            react_1.default.createElement(SSLOptionContent, { errors: sshTunnelErrors === null || sshTunnelErrors === void 0 ? void 0 : sshTunnelErrors.errors, sshTunnelOptions: connectionOptions.sshTunnel, onConnectionOptionChanged: onConnectionOptionChanged })))));
}
exports.default = SSHTunnel;
//# sourceMappingURL=ssh-tunnel-tab.js.map