"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const css_1 = require("@emotion/css");
const react_1 = __importDefault(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const form_field_container_1 = __importDefault(require("../../form-field-container"));
const caFieldsContainer = (0, css_1.css)({
    width: '70%',
});
const removeFileButtonStyles = (0, css_1.css)({
    marginLeft: compass_components_1.spacing[1],
});
function TLSCertificateAuthority({ connectionStringUrl, disabled, updateCAFile, }) {
    const caFile = connectionStringUrl
        .typedSearchParams()
        .get('tlsCAFile');
    return (react_1.default.createElement(form_field_container_1.default, { className: caFieldsContainer },
        react_1.default.createElement(compass_components_1.FileInput, { description: 'Learn More', disabled: disabled, id: "tlsCAFile", label: "Certificate Authority (.pem)", link: 'https://docs.mongodb.com/manual/reference/connection-string/#mongodb-urioption-urioption.tlsCAFile', onChange: (files) => {
                updateCAFile(files && files.length > 0 ? files[0] : null);
            } }),
        caFile && (react_1.default.createElement("div", null,
            caFile,
            react_1.default.createElement(compass_components_1.IconButton, { className: removeFileButtonStyles, "aria-label": "Remove CA file", onClick: () => {
                    updateCAFile(null);
                } },
                react_1.default.createElement(compass_components_1.Icon, { glyph: "X" }))))));
}
exports.default = TLSCertificateAuthority;
//# sourceMappingURL=tls-certificate-authority.js.map