"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTLSOptionForConnectionString = void 0;
const css_1 = require("@emotion/css");
const react_1 = __importStar(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const form_field_container_1 = __importDefault(require("../../form-field-container"));
const descriptionStyles = (0, css_1.css)({
    marginTop: compass_components_1.spacing[1],
});
const TLS_TYPES = [
    {
        value: 'DEFAULT',
        label: 'Default',
        description: 'Default (unset) – TLS/SSL will be used when connecting using a DNS Seed List Connection Format (mongodb+srv://) and it will not be used when connecting using a standard connection string schema format (mongodb://).',
    },
    {
        value: 'ON',
        label: 'On',
        description: 'On – TLS/SSL is enabled for this connection.',
    },
    {
        value: 'OFF',
        label: 'Off',
        description: 'Off – TLS/SSL is disabled for this connection.',
    },
];
function getTLSOptionForConnectionString(connectionStringUrl) {
    const searchParams = connectionStringUrl.typedSearchParams();
    if (searchParams.get('ssl') === null && searchParams.get('tls') === null) {
        return 'DEFAULT';
    }
    if (searchParams.get('tls') === 'true' &&
        (searchParams.get('ssl') === null || searchParams.get('ssl') === 'true')) {
        return 'ON';
    }
    if (searchParams.get('tls') === 'false' &&
        (searchParams.get('ssl') === null || searchParams.get('ssl') === 'false')) {
        return 'OFF';
    }
    if (searchParams.get('ssl') === 'true' && searchParams.get('tls') === null) {
        return 'ON';
    }
    if (searchParams.get('ssl') === 'false' && searchParams.get('tls') === null) {
        return 'OFF';
    }
}
exports.getTLSOptionForConnectionString = getTLSOptionForConnectionString;
function TLSTab({ connectionStringUrl, updateConnectionFormField, }) {
    var _a;
    const tlsOption = getTLSOptionForConnectionString(connectionStringUrl);
    const onChangeTLSOption = (0, react_1.useCallback)((event) => {
        updateConnectionFormField({
            type: 'update-tls-option',
            tlsOption: event.target.value,
        });
    }, [updateConnectionFormField]);
    return (react_1.default.createElement("div", null,
        react_1.default.createElement(form_field_container_1.default, null,
            react_1.default.createElement(compass_components_1.Label, { htmlFor: "connection-schema-radio-box-group" }, "SSL/TLS Connection"),
            react_1.default.createElement(compass_components_1.RadioBoxGroup, { value: tlsOption || '', onChange: onChangeTLSOption }, TLS_TYPES.map((tlsType) => (react_1.default.createElement(compass_components_1.RadioBox, { value: tlsType.value, key: tlsType.value }, tlsType.label)))),
            react_1.default.createElement(compass_components_1.Description, { className: descriptionStyles }, ((_a = TLS_TYPES.find((tlsType) => tlsType.value === tlsOption)) === null || _a === void 0 ? void 0 : _a.description) || ''))));
}
exports.default = TLSTab;
//# sourceMappingURL=tls-ssl-tab.js.map