"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const css_1 = require("@emotion/css");
const react_1 = __importDefault(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const connection_string_input_1 = __importDefault(require("./connection-string-input"));
const advanced_connection_options_1 = __importDefault(require("./advanced-connection-options"));
const connect_form_actions_1 = __importDefault(require("./connect-form-actions"));
const use_connect_form_1 = require("../hooks/use-connect-form");
const formContainerStyles = (0, css_1.css)({
    margin: 0,
    padding: 0,
    height: 'fit-content',
    flexGrow: 1,
    minWidth: 650,
    maxWidth: 760,
    position: 'relative',
    display: 'inline-block',
});
const formCardStyles = (0, css_1.css)({
    margin: 0,
    padding: compass_components_1.spacing[2],
    height: 'fit-content',
    width: '100%',
    position: 'relative',
});
const descriptionStyles = (0, css_1.css)({
    marginTop: compass_components_1.spacing[2],
});
const formContentContainerStyles = (0, css_1.css)({
    padding: compass_components_1.spacing[4],
});
function ConnectForm({ initialConnectionInfo, onConnectClicked, }) {
    const [{ errors, connectionStringUrl, connectionStringInvalidError, connectionOptions, }, { updateConnectionFormField, setConnectionStringUrl, setConnectionStringError, hideError, },] = (0, use_connect_form_1.useConnectForm)(initialConnectionInfo);
    const editingConnectionStringUrl = connectionStringUrl;
    return (react_1.default.createElement("div", { className: formContainerStyles, "data-testid": "new-connect-form" },
        react_1.default.createElement(compass_components_1.Card, { className: formCardStyles },
            react_1.default.createElement("div", { className: formContentContainerStyles },
                react_1.default.createElement(compass_components_1.H3, null, "New Connection"),
                react_1.default.createElement(compass_components_1.Description, { className: descriptionStyles }, "Connect to a MongoDB deployment"),
                react_1.default.createElement(connection_string_input_1.default, { connectionString: editingConnectionStringUrl.toString(), setConnectionStringUrl: setConnectionStringUrl, setConnectionStringError: setConnectionStringError }),
                connectionStringInvalidError && (react_1.default.createElement(compass_components_1.Banner, { variant: compass_components_1.BannerVariant.Danger }, connectionStringInvalidError)),
                react_1.default.createElement(advanced_connection_options_1.default, { errors: errors, hideError: hideError, disabled: !!connectionStringInvalidError, connectionStringUrl: editingConnectionStringUrl, updateConnectionFormField: updateConnectionFormField, connectionOptions: connectionOptions })),
            react_1.default.createElement(connect_form_actions_1.default, { onConnectClicked: () => onConnectClicked({
                    ...initialConnectionInfo,
                    connectionOptions: {
                        ...connectionOptions,
                        connectionString: editingConnectionStringUrl.toString(),
                    },
                }) }))));
}
exports.default = ConnectForm;
//# sourceMappingURL=connect-form.js.map