"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const css_1 = require("@emotion/css");
const react_1 = __importStar(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const connection_string_input_1 = __importDefault(require("./connection-string-input"));
const advanced_connection_options_1 = __importDefault(require("./advanced-connection-options"));
const formContainerStyles = css_1.css({
    margin: 0,
    padding: compass_components_1.spacing[4],
    height: 'fit-content',
    flexGrow: 1,
    minWidth: 400,
    maxWidth: 760,
    position: 'relative',
    display: 'inline-block',
});
const formCardStyles = css_1.css({
    margin: 0,
    padding: compass_components_1.spacing[2],
    height: 'fit-content',
    width: '100%',
    position: 'relative',
});
const descriptionStyles = css_1.css({
    marginTop: compass_components_1.spacing[2],
});
const formContentContainerStyles = css_1.css({
    padding: compass_components_1.spacing[4],
});
const formActionStyles = css_1.css({
    padding: compass_components_1.spacing[4],
    borderTop: `1px solid ${compass_components_1.uiColors.gray.light2}`,
    textAlign: 'right',
});
function ConnectForm({ initialConnectionInfo, onConnectClicked, }) {
    const [connectionString, setConnectionString] = react_1.useState(initialConnectionInfo.connectionOptions.connectionString);
    return (react_1.default.createElement("div", { className: formContainerStyles, "data-testid": "new-connect-form" },
        react_1.default.createElement(compass_components_1.Card, { className: formCardStyles },
            react_1.default.createElement("div", { className: formContentContainerStyles },
                react_1.default.createElement(compass_components_1.H3, null, "New Connection"),
                react_1.default.createElement(compass_components_1.Description, { className: descriptionStyles }, "Connect to a MongoDB deployment"),
                react_1.default.createElement(connection_string_input_1.default, { connectionString: connectionString, setConnectionString: setConnectionString }),
                react_1.default.createElement(advanced_connection_options_1.default, null)),
            react_1.default.createElement("div", { className: formActionStyles },
                react_1.default.createElement(compass_components_1.Button, { variant: compass_components_1.ButtonVariant.Primary, onClick: () => onConnectClicked({
                        ...initialConnectionInfo,
                        connectionOptions: {
                            ...initialConnectionInfo.connectionOptions,
                            connectionString,
                        },
                    }) }, "Connect")))));
}
exports.default = ConnectForm;
//# sourceMappingURL=connect-form.js.map