"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleUpdateTlsOption = void 0;
function handleUpdateTlsOption({ tlsOption, connectionStringUrl, connectionOptions, }) {
    const updatedConnectionString = connectionStringUrl.clone();
    const updatedSearchParams = updatedConnectionString.typedSearchParams();
    if (tlsOption === 'ON') {
        updatedSearchParams.delete('ssl');
        updatedSearchParams.set('tls', 'true');
    }
    else if (tlsOption === 'OFF') {
        updatedSearchParams.delete('ssl');
        updatedSearchParams.set('tls', 'false');
    }
    else if (tlsOption === 'DEFAULT') {
        updatedSearchParams.delete('ssl');
        updatedSearchParams.delete('tls');
    }
    return {
        errors: [],
        connectionStringUrl: updatedConnectionString,
        connectionOptions: {
            ...connectionOptions,
            connectionString: updatedConnectionString.toString(),
        },
    };
}
exports.handleUpdateTlsOption = handleUpdateTlsOption;
//# sourceMappingURL=tls-options.js.map